=== example/array/CMakeLists.txt ===
ADD_EXAMPLE(falseloc)
ADD_EXAMPLE(trueloc)
