=== example/constants/CMakeLists.txt ===
ADD_EXAMPLE(constants)
